Lttcmprsk_Prob <- function(xcmp, cmprsk){
  if(class(xcmp)=="data.frame"){
    if(ncol(xcmp)==1){
      xcmp <- as.vector(xcmp)
    } else{
      xcmp <- xcmp[,1]
      if("tmin" %in% colnames(xcmp)){
        xcmp <- xcmp["tmin"]
      }
    }
  }
  margs.para.list <- cmprsk$margs.para.list
  pdist.list <- lapply(paste0("p", cmprsk$margins), get)
  ddist.list <- lapply(paste0("d", cmprsk$margins), get)
  Ftval <- Rtval <- ftval <- matrix(0, nrow=length(xcmp), ncol=length(cmprsk$margins))
  for(i in 1:length(pdist.list)){
    pdist <- pdist.list[[i]]
    para.pcall <- margs.para.list[[i]]
    para.pcall$q <- xcmp
    Ftval[,i] <- do.call(pdist, para.pcall)
    Rtval[,i] <- 1-Ftval[,i]
    
    para.dcall <- margs.para.list[[i]]
    para.dcall$x <- xcmp
    
    ddist <- ddist.list[[i]]
    ftval[,i] <- do.call(ddist, para.dcall)
  }
  Rxcmp <- apply(Rtval, 1, prod)
  Fxcmp <- 1-Rxcmp
  
  fxcmp0 <- sapply(1:length(cmprsk$margins), 
                   function(x) ftval[,x]/Rtval[,x]*apply(Rtval, 1, prod))
  if(nrow(fxcmp0)==1 || class(fxcmp0)=="numeric"){
    fxcmp <- sum(fxcmp0)
  } else{
    fxcmp <- apply(fxcmp0, 1, sum)
  }
  
  fxcmp
  hxcmp <- fxcmp/Rxcmp
  hxcmp
  
  hxcmp0 <- sapply(1:length(cmprsk$margins), function(x) ftval[,x]/Rtval[,x])
  # apply(hxcmp0, 1, sum) # to check hxcmp is right
  marg.prob <- list(ftval=ftval, Ftval=Ftval, Rtval=Rtval, htval=hxcmp0)
  cmprsk.prob <- list(fxcmp=fxcmp, Fxcmp=Fxcmp, Rxcmp=Rxcmp, hxcmp=hxcmp, 
                      fxcmpmat=fxcmp0, hxcmpmat=hxcmp0)
  list(cmprsk.prob=cmprsk.prob, marg.prob=marg.prob)
}

Rxcmpf <- function(xcmp, u, cmprsk){
  y <- log(Lttcmprsk_Prob(xcmp=xcmp, cmprsk = cmprsk)$cmprsk.prob$Rxcmp)
  y-log(u)
}

Fxcmpf <- function(xcmp, u, cmprsk){
  y <- Lttcmprsk_Prob(xcmp=xcmp, cmprsk = cmprsk)$cmprsk.prob$Fxcmp
  abs(log(y)-log(u))
}

