ParaTrsfm <- function(para.vec, cmprsk, x=1, fname=c("reliability", "hazard", "newf"),
                      Newf=NULL){
  d <- length(cmprsk$margins)
  np.vec <- sapply(cmprsk$margs.para.list, length)
  para.list <- ParavecToList(para0.vec = para.vec, np.vec=np.vec)
  para.list <- LttCmpRsk(margins = cmprsk$margins, para.list = para.list)$margs.para.list
  xcmp.prob <- Lttcmprsk_Prob(xcmp=x, cmprsk = cmprsk)
  if(fname=="reliability"){
    y <- xcmp.prob$cmprsk.prob$Rxcmp
  }
  if(fname=="hazard"){
    y <- xcmp.prob$cmprsk.prob$hxcmp
  }
  if(fname=="newf"){
    stopifnot(!is.null(Newf))
    y <- Newf(para.vec)
  }
  y
}

ParaTrsfmDiff <- function(para.vec, cmprsk, x=1, 
                          fname=c("reliability", "hazard", "newf"),
                          NewfDiff=NULL){
  d <- length(cmprsk$margins)
  np.vec <- sapply(cmprsk$margs.para.list, length)
  para.list <- ParavecToList(para0.vec = para.vec, np.vec=np.vec)
  para.list <- LttCmpRsk(margins = cmprsk$margins, para.list = para.list)$margs.para.list
  if(fname=="reliability"){
    y <- xcmp.prob$cmprsk.prob$Rxcmp
    ydiff <- NULL
    for (i in 1:d){
      c1 <- para.list[[3-i]]$shape^((-1)*exp((-1)*para.list[[3-i]]$scale*x))-1
      c2 <- para.list[[3-i]]$shape*c1/((para.list[[3-i]]$shape-1)*(para.list[[i]]$shape-1))
      v <- exp((-1)*para.list[[i]]$scale*x)
      w <- para.list[[i]]$shape^((-1)*v)
      c3 <- (w-1)*(1-para.list[[i]]$shape/(para.list[[i]]$shape-1))-v*w
      yd1 <- c2*c3
      
      c2 <- para.list[[3-i]]$shape*para.list[[i]]$shape/((para.list[[3-i]]$shape-1)*(para.list[[i]]$shape-1))
      c3 <- x*log(para.list[[i]]$shape)*v*w*c1
      yd2 <- c2*c3
      ydiff[[i]] <- c(yd1, yd2)
    }
    ydiff <- unlist(ydiff)
  }
  if(fname=="hazard"){
    y <- xcmp.prob$cmprsk.prob$hxcmp
    ydiff <- NULL
    for (i in 1:d){
      v <- exp((-1)*para.list[[i]]$scale*x)
      w <- para.list[[i]]$shape^((-1)*v)
      c1 <- para.list[[i]]$scale*v/((para.list[[i]]$shape)*(1/w-1))
      c2 <- 1-v*log(para.list[[i]]$shape)/(1-w)
      yd1 <- c1*c2
      
      c1 <- v*log(para.list[[i]]$shape)/(1/w-1)
      c2 <- v*x*log(para.list[[i]]$shape)*para.list[[i]]$scale/(1-w)
      c3 <- 1-para.list[[i]]$scale*x-c2
      yd2 <- c1*c3
      ydiff[[i]] <- c(yd1, yd2)
    }
    ydiff <- unlist(ydiff)
  }
  if(fname=="newf"){
    stopifnot(!is.null(Newf))
    ydiff <- NewfDiff(para.vec)
  }
  ydiff
}
