partialDeriv.Rfun <- function(x, parav, cmprsk){
  np.vec <- sapply(cmprsk$margs.para.list, length)
  para0.list <- ParavecToList(para0.vec = parav, np.vec=np.vec)
  cmprsk <- LttCmpRsk(margins = cmprsk$margins, para.list = para0.list)
  cmprob <- Lttcmprsk_Prob(xcmp=x, cmprsk = cmprsk)
  fxcmp <- cmprob$cmprsk.prob$fxcmp
  Rxcmp <- cmprob$cmprsk.prob$Rxcmp
  ylist <- list()
  for(i in 1:length(cmprsk$margins)){
    parai <- cmprsk$margs.para.list[[i]]
    para3i <- cmprsk$margs.para.list[[3-i]]
    c1 <- para3i$shape*(para3i$shape^((-1)*exp((-1)*x*para3i$scale))-1)
    c2 <- (parai$shape-1)*(para3i$shape-1)
    c3 <- parai$shape^((-1)*exp((-1)*x*parai$scale))-1
    c4 <- 1 - parai$shape/(parai$shape-1)
    c5 <- exp((-1)*x*parai$scale)*parai$shape^((-1)*exp((-1)*x*parai$scale))
    y1 <- (c1/c2)*(c3*c4-c5)
    
    
    c1 <- parai$shape*para3i$shape
    c2 <- (parai$shape-1)*(para3i$shape-1)
    c3 <- x*log(parai$shape)
    c4 <- exp((-1)*x*parai$scale)*parai$shape^((-1)*exp((-1)*x*parai$scale))
    c5 <- (para3i$shape^((-1)*exp((-1)*x*para3i$scale))-1)
    y2 <- (c1/c2)*c3*c4*c5
    ylist[[i]] <- c(shape=y1,scale=y2)
  }
  list(partial=ylist, value=Rxcmp)
}

partialDeriv.hfun <- function(x, parav, cmprsk){
  np.vec <- sapply(cmprsk$margs.para.list, length)
  para0.list <- ParavecToList(para0.vec = parav, np.vec=np.vec)
  cmprsk <- LttCmpRsk(margins = cmprsk$margins, para.list = para0.list)
  cmprob <- Lttcmprsk_Prob(xcmp=x, cmprsk = cmprsk)
  fxcmp <- cmprob$cmprsk.prob$fxcmp
  Rxcmp <- cmprob$cmprsk.prob$Rxcmp
  hxcmp <- cmprob$cmprsk.prob$hxcmp
  
  ylist <- list()
  for(i in 1:length(cmprsk$margins)){
    parai <- cmprsk$margs.para.list[[i]]
    shape <- parai$shape
    scale <- parai$scale
    
    A <- scale
    B <- log(shape)
    C <- exp((-1)*scale*x)
    D <- shape^((-1)*C)
    E <- (1 - D)^(-1)
    v0 <- c(A, B, C,D, E)
    
    vt <- v0
    
    vt[1] <- 0
    vt[2] <- 1/shape
    vt[3] <- 0
    vt[4] <- (-1)*C*shape^(-C-1)
    vt[5] <- (-1)*(1-D)^2*(-1)*vt[4]
    v1 <- vt
    
    vt[1] <- 1
    vt[2] <- 0
    vt[3] <- C*(-x)
    vt[4] <- D*log(shape)*(-1)*vt[3]
    vt[5] <- (-1)*(1-D)^2*(-1)*vt[4]
    v2 <- vt
    
    y1 <- sum(unlist(lapply(1:5, function(x) v1[x]*prod(v0[-x]))))
    y2 <- sum(unlist(lapply(1:5, function(x) v2[x]*prod(v0[-x]))))
    
    ylist[[i]] <- c(shape=y1,scale=y2)
  }
  list(partial=ylist, value=hxcmp)
}